package Spectro;
import java.awt.*;
import java.awt.List;
import java.awt.event.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.*;
import javax.swing.border.Border;

import java.io.*;
import java.text.CharacterIterator;
import java.text.NumberFormat;
import java.text.StringCharacterIterator;
import java.util.*;
/**
 * This class is used to create teacher GUI including an area that
 * allows user to input words and 5 formatted field used to change 
 * Samples' values.
 * @author   Chao Han
 * @version  1.1 Nov 11 2012
 */

public class TeacherGUI extends JFrame{
	/*Using components in javax.swing and java.awt for implementation */
	/**
	 * Label for Information Board
	 */
	private JLabel infoBoardLabel;
	/**
	 * the text area to input information*/
	private JTextArea infoBoardField;
	
	/**
	 * a set FormattedTextField to change Sample Value;*/
	private JFormattedTextField sampleValueField1;
	private JFormattedTextField sampleValueField2;
	private JFormattedTextField sampleValueField3;
	private JFormattedTextField sampleValueField4;
	private JFormattedTextField sampleValueField5;
	/**
	 * Sample values' format*/
	private NumberFormat sampleFormat;
	/**
	 * Labels for SampleValueFields*/
	private JLabel sampleLable1;
	private JLabel sampleLable2;
	private JLabel sampleLable3;
	private JLabel sampleLable4;
	private JLabel sampleLable5;
	
	/**
	 * Button for saving
	 */
	private JButton saveButton;
	/**
	 * Button for canceling
	 */
	private JButton cancelButton;
	
	/**
	 * constructor of class TeacherGUI which creates the GUI for displaying.
	 */
	public TeacherGUI(){
		super("Configuration");
		setLayout(new BorderLayout());
			
		infoBoardLabel = new JLabel("Update information below:");
		FileMgmt infoFile = new FileMgmt();
		infoBoardField = new JTextArea(infoFile.readFile("InfoBoard.txt"),10,10);
		infoBoardField.setLineWrap(true);
		infoFile.closeFile("InfoBoard.txt");
		
		/*interface of setting samples' value*/
		sampleLable1 = new JLabel("Sample 1");
		sampleLable2 = new JLabel("Sample 2");
		sampleLable3 = new JLabel("Sample 3");
		sampleLable4 = new JLabel("Sample 4");
		sampleLable5 = new JLabel("Sample 5");
		
		SampleFileMgmt file = new SampleFileMgmt();                     
		
		/*set value displayed in FormattedTextField as the value 
		 *stored in SampleValues file*/
		sampleValueField1 = new JFormattedTextField(sampleFormat);
		sampleValueField1.setValue(new Double(file.readSampleFile("SampleValues.txt",0)));
		sampleValueField1.setColumns(10);
		
		sampleValueField2 = new JFormattedTextField(sampleFormat);
		sampleValueField2.setValue(new Double(file.readSampleFile("SampleValues.txt",1)));
		sampleValueField2.setColumns(10);
		
		sampleValueField3 = new JFormattedTextField(sampleFormat);
		sampleValueField3.setValue(new Double(file.readSampleFile("SampleValues.txt",2)));
		sampleValueField3.setColumns(10);
		
		sampleValueField4 = new JFormattedTextField(sampleFormat);
		sampleValueField4.setValue(new Double(file.readSampleFile("SampleValues.txt",3)));
		sampleValueField4.setColumns(10);
		
		sampleValueField5 = new JFormattedTextField(sampleFormat);
		sampleValueField5.setValue(new Double(file.readSampleFile("SampleValues.txt",4)));
		sampleValueField5.setColumns(10);
		file.closeFile("SampleValues.txt");
		
		/*buttons*/
		saveButton = new JButton("Save");
		cancelButton = new JButton("Cancel");	
		/*Button handler*/
		ButtonHandler handler = new ButtonHandler();
		saveButton.addActionListener(handler);
		cancelButton.addActionListener(handler);
		
		/*3 panels*/
		JPanel infoBoardPanel = new JPanel();
		infoBoardPanel.setLayout(new BoxLayout(infoBoardPanel, BoxLayout.Y_AXIS));
		JPanel valuesPanel = new JPanel();
		valuesPanel.setLayout(new BoxLayout(valuesPanel, BoxLayout.Y_AXIS));
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new FlowLayout());
		
		/*add components to infoBoardPanel*/
		infoBoardPanel.add(infoBoardLabel);
		infoBoardPanel.add(infoBoardField);
		/*add components to valuesPanel*/
		valuesPanel.add(sampleLable1);
		valuesPanel.add(sampleValueField1);
		valuesPanel.add(sampleLable2);
		valuesPanel.add(sampleValueField2);
		valuesPanel.add(sampleLable3);
		valuesPanel.add(sampleValueField3);
		valuesPanel.add(sampleLable4);
		valuesPanel.add(sampleValueField4);
		valuesPanel.add(sampleLable5);
		valuesPanel.add(sampleValueField5);
		/*add buttons to buttonPanel*/
	    buttonPanel.add(saveButton);
	    buttonPanel.add(cancelButton);	
		
	    /*set border for each panel*/
		Border paneEdge = BorderFactory.createEmptyBorder(20,20,20,20);      //border 
		rootPane.setBorder(paneEdge);
		infoBoardPanel.setBorder(paneEdge);
		valuesPanel.setBorder(paneEdge);
		
		/*add panels to JFrame*/
		add(infoBoardPanel, BorderLayout.CENTER);
		add(valuesPanel, BorderLayout.EAST);
		add(buttonPanel, BorderLayout.SOUTH);
	
	}
	/**
	 * This method is used to create and show GUI.
	 */
	public static void createAndShowGUI(){
		TeacherGUI teacherGUI = new TeacherGUI();
		teacherGUI.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		teacherGUI.pack();
		teacherGUI.setVisible(true);
	}
	
	/**
	 * This is a private class implements interface ActionListener. When Save button 
	 * is clicked, the infoBoard and sample values is save to specified file. When 
	 * cancel button is click, nothing is changed. And after save or cancel, it will go 
	 * back to the loginGUI. 
	 * @author Chao Han
	 */
	private class ButtonHandler implements ActionListener{
		/**
		 * This method override the only method interface ActionListener, actionPerformed.
		 * This method controls two buttons, save and cancel. Therefore, it need to decide
		 * which button is clicked and then response to that button. 
		 */
		@Override 
		public void actionPerformed(ActionEvent event){

			
			
			/*if save is clicked */
			if(event.getActionCommand()== "Save"){
				FileMgmt InfoFile = new FileMgmt();          //file that stores input infoBoard
				FileMgmt ValueFile = new FileMgmt();         //file that stores input sample values
				String SampleValues = "";                    //an empty String that stores all values
				
				/*write to information to file*/
				InfoFile.writeFile("InfoBoard.txt", infoBoardField.getText(),false);
				
				/*add values to SampleValues String*/
				SampleValues = sampleValueField1.getText()+"\n"+sampleValueField2.getText()
						+"\n"+sampleValueField3.getText()+"\n"+sampleValueField4.getText()
						+"\n"+sampleValueField5.getText()+"\n";
				/*write values to file*/
				ValueFile.writeFile("SampleValues.txt",SampleValues,false);
			
				JOptionPane.showMessageDialog(null, "saved successfully");
				}
			
			/*if cancel button is clicked*/
			if(event.getActionCommand()== "Cancel"){
				JOptionPane.showMessageDialog(null, "nothing changes");
			}
			
			/*close the windows*/
			dispose();
			
			/*back to login GUI*/
			LoginGUI.createAndShwoGUI();
		}
	}
	
	/**
	 * This class extends FileMgmt class in order to get double type.
	 * Because samples' values are double but not string, this class 
	 * need to make sure that the values displayed in the teacherGUI 
	 * are double. Otherwise, error occurs. 
	 * @author Chao Han
	 */
	private class SampleFileMgmt extends FileMgmt{
		
		/*A method named readSampleFile is added to this class.*/
		/**
		 * This method returns the desired double value at a specified 
		 * index 
		 * @see      FileMgmt     
		 * @param    fileName the file name that stores Samples' values
		 * @param    lineIndex the index of samples
		 * @return   the desired value in double
		 */
		public double readSampleFile(String fileName,int lineIndex){	
			openFile(fileName);
			double [] LineContent = {0,0,0,0,0};
			int index = 0;
			while(fileData.hasNext()){
				LineContent[index] = fileData.nextDouble();
				System.out.println(LineContent[index]);
				index++;
			}
			return LineContent[lineIndex];
		}
	}
}