package biology.spectro.collaboration;

/**
 * This class is Account type in this application. It includes three parts, an 
 * id, an password and an account type
 * @author Chao Han
 * @version 1.0 11 Nov 2012
 */
public class Account {
    /*ID*/
    private String ID;
    /*Password*/
    private String Password;
    /*Account type, 1 for teacher, 2 for student*/
    private int AccountType;
    /**
     *constructor for Account class, initializing Account 
     */
    public Account(){
		ID = "000000";
		Password = "aaaa1111";
		AccountType = 1;	
	}
     /**
     * Constructor for Account class
     * @param id     id    
     * @param pw     password
     * @param type   account type
     */
    public Account(String id,String pw,int type ){
		ID = id;
		Password = pw;
		AccountType = type;
	}
    /**
     * Constructor for Account class
     * @param id      id
     * @param pw      password
     * @param type    account type
     */
    public Account(String id, char[] pw, int type){
		ID = id;
		Password = new String(pw);
		AccountType = type;
	}
	
     /**
     * Getter for getting private Id in Account;
     * @return  id in String
     */
    public String getID(){
		return ID;
	}
    /**
     * Getter for getting private password in Account
     * @return   password in String
     */
    public String getPassword(){
		return Password;
	}
     /**
     * Getter for getting account type
     * @return   account type in int
     *           1 for teacher, 2 for student 
     */
    public int getAccountType(){
		return AccountType;
	}

    /**
     * Setter for changing id value
     * @param id
     */
    public void setID(String id){
		ID = id;
	}
    /**
     * Setter for changing password value
     * @param pw
     */
    public void setPassword(String pw){
		Password = pw;
	}
    /**
     * Setter for changing account type
     * @param type
     */
    public void setAccountType(int type){
		AccountType = type;
	}
	
    /**
     * Print account information on screen
     */
    public void printAccount(){
		System.out.println(AccountType+" "+ID+" "+ Password);
	}
	
    /**
     * Check if two Account are equal
     * @param     ac another Account 
     * @return    true for same, false for difference
     */
    public boolean equals(Account ac){
		if(getID().equals(ac.getID())&&getPassword().equals(ac.getPassword())&&
				getAccountType()==ac.getAccountType()){
			return true;
		}
		else
			return false;
	}

}
