
package biology.spectro.domain;

import biology.domain.LabObject;
import flatscape.domain.Transform2D;
import manifold.domain.CreateGlyphCommand;
import manifold.domain.GlyphProperty;

/**
 * This class extends class LabObject
 * @author Chao Han
 */
public class AbsorbanceMeter extends LabObject {
	
	/**
	 * Constructor for class AbsorbanceMeter. Adds properties to AbsorbanceMeter
	 * @param cmd
	 * @param transform
	 */
	public AbsorbanceMeter(CreateGlyphCommand cmd, Transform2D transform) {
		super(cmd, transform);
		addGlyphProperty("absorbanceMeter.needEnlargedView", 
				new GlyphProperty(new Boolean(false), 
						"tells if the enlarged view is necessary", true));
		addGlyphProperty("absorbanceMeter.transmittanceReading", 
				new GlyphProperty(new Integer(0), 
						"holds the percentage transmittance value", true));
		addGlyphProperty("glyph.toolTip", 
				new GlyphProperty(new String("AbsorbanceMeter"), 
						"Tool tip for the glyph", true));
	}

	/**
	 * 
	 */
	public void grasp() {
		putPropertyValue("absorbanceMeter.needEnlargedView", new Boolean(true));
		super.grasp();
		
		Transform2D localTransform2D = new Transform2D(((Transform2D)getTransform()).x_,
			((Transform2D)getTransform()).y_, 0.0D);
		transform(localTransform2D);
	}
}
