package biology.spectro.domain;

import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;

/**
 * Implements back button function, go back to the previous states by clicking 
 * back button
 * @author Chao Han
 * 
 */
public class BackButtonWatcher implements Behavior, PropertyValueChangeListener {
	private SpectroBehavior spectro;
	
	/**
	 * adds target to backButtonWatcher
	 */
	public void addTarget(String componentName, Object obj) {
		if (componentName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)obj);

			System.out.println("spectroBehavior Target added to BackButtonWatcher...");
		} else {
			System.err.println("BackButtonWatcher.addTarget: Unknown target " + componentName);
    }
}
    
	/**
	 * changes property value if back button is clicked
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event) {
		if (event.key_.equals("backButton.isActivated"))
		{
			boolean backButtonIsActivated = ((Boolean)event.
					source_.getPropertyValue("backButton.isActivated")).booleanValue();
			if (!backButtonIsActivated){
				spectro.undoLastCommand();
			}
				
		}
	}
}