package biology.spectro.domain;

import biology.domain.NextButton;
import jess.JessException;
import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;
/**
 * implement button behaviors 
 * @author Chao Han
 *
 */
public class ButtonWatcher implements Behavior, PropertyValueChangeListener {
	private SpectroBehavior spectro;
	private int stageNumber = 1;
	
	/**
	 * adds target to ButtonWatcher
	 */
	public void addTarget(String componentName, Object obj) {
		if (componentName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)obj);

			System.out.println("spectroBehavior Target added to ButtonWatcher...");
		}
		else {
			System.err.println("ButtonWatcher.addTarget: Unknown target " + componentName);
    }
	}

	/**
	 * Changes property value if next button is clicked
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event) {
		if (event.key_.equals("button.isActivated")) {
			boolean buttonIsActivated = ((Boolean)event.source_.
					getPropertyValue("button.isActivated")).booleanValue();
			if (!buttonIsActivated) {
				((NextButton)event.source_).putPropertyValue("image.location", 
						"biology/spectro/resources/nextInActive.gif");
			} else {
				((NextButton)event.source_).putPropertyValue("image.location", 
						"biology/spectro/resources/nextActive.gif");
			}
		}
		if (event.key_.equals("button.isClicked")) {
			boolean buttonIsClicked= ((Boolean)event.source_.
					getPropertyValue("button.isClicked")).booleanValue();
			if (buttonIsClicked) {
				try {
					spectro.setInstructions();
				} catch (JessException localJessException) {
					System.out.println("Exception in ButtonWatcher..." + localJessException);
				}
				event.source_.putPropertyValue("button.isClicked", new Boolean(false));
			}
		}
	}
}
