package biology.spectro.domain;

import java.io.PrintStream;
import manifold.domain.Behavior;

/**
 * This class implements behaviors of current test tube
 * @author Chao Han
 *
 */
public class CurrentTestTube implements Behavior {
	private TestTubeFigure  testTube;
	private long            id;
	private TestTubeFigure  tempTestTube;
	private long            tempId;
	private SpectroBehavior spectro;

	/**
	 * sets test tube
	 * @param testTubeFigure
	 * @param objId
	 */
	public void setTestTube(TestTubeFigure testTubeFigure, long objId) {
		testTube = testTubeFigure;

		id = objId;
		this.spectro.setTestTube(testTube);
	}

	
	/**
	 * remembers old settings
	 * @param testTubeFigure
	 * @param id
	 */
	public void rememberOldSettings(TestTubeFigure testTubeFigure, long id) {
		tempTestTube = testTubeFigure;
		tempId = id;
	}
	
	/**
	 * resets test tube
	 */
	public void resetTestTube() {
		System.out.println("The temp Id in CTT is :" + tempId);
		spectro.resetTestTube(this.tempTestTube, tempId);
	}
 
	/**
	 * sees if test tube can be placed
	 */
	public void seeIfTestTubeCanBePlaced() {
		spectro.seeIfTestTubeCanBePlaced();
	}
	
	/**
	 * gets test tube
	 * @return testTube
	 */
	public TestTubeFigure getTestTube() {
		return testTube;
	}

	/**
	 * adds targets to spectroBehavior
	 */
	public void addTarget(String componentName, Object obj) {
		if (componentName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)obj);
			System.out.println("spectroBehavior Target added to CurrentTestTube...");
		} else {
			System.err.println("CurrentTestTube.addTarget()...Unknown Target ");
		}
	}

	public void setHolderOccupied(boolean isHolderOccupied) {
		spectro.setHolderOccupied(isHolderOccupied);
	}

	public void setCovered(boolean isCovered) {
		spectro.setCovered(isCovered);
	}
}
