package biology.spectro.domain;

import biology.domain.LabObject;
import flatscape.domain.Transform2D;
import java.awt.geom.AffineTransform;
import manifold.domain.CreateGlyphCommand;
import manifold.domain.GlyphProperty;
 
public class Dial extends LabObject {
	
	/**
	 * fires measurement 
	 */
	public void transform(AffineTransform at) {
		super.transform(at);
		fireMeasureEvent();
	}

	/**
	 *  Method Dial: set dial properties, including minAngle and maxAngle 
	 * @param cmd
	 * @param transform
	 */
	public Dial(CreateGlyphCommand cmd, Transform2D transform) {
		super(cmd, transform);

		addGlyphProperty("dial.minAngle", new GlyphProperty(new Float(0.0F), "Dial's minimum rotation angle", true));
		addGlyphProperty("dial.maxAngle", new GlyphProperty(new Float(0.0F), "Dial's maximum rotation angle", true));
	}
}

