/*
 * Dials.java
 * set rotation function of each dial
 * 
 * version: 1.1.1
 * 
 * date: 12-12-08
 * 
 * Copyright: Bingbing Xu, ...
 */
package biology.spectro.domain;
 
import flatscape.domain.PolyGlyph2D;
import java.awt.geom.AffineTransform;
import manifold.domain.CreateGlyphCommand;
import manifold.domain.Glyph;
import manifold.domain.GlyphProperty;
import manifold.domain.TransformEvent;

public class Dials extends PolyGlyph2D {
	/**
	 * Add rotation function to the dial
	 * @param cmd
	 * @param obj
	 */
	public Dials(CreateGlyphCommand cmd, Object obj) {
		super(cmd, obj);
		addGlyphProperty("waveDial.isMovable", new GlyphProperty(new Boolean(true), 
				"tells if the wave dial is within the range for motion", true));
	}
	
	/**
	 * method of releasing dials
	 */
	public void release() {
		fireReleaseEvent(new TransformEvent(this, new AffineTransform()));
	 }

	/**
	 * method of grasping dials
	 */
	public void grasp() {
		fireGraspEvent(new TransformEvent(this, new AffineTransform()));
	}
}
