package biology.spectro.domain;

import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;

/**
 * This class implements functions of exit button
 * @author Chao Han
 *
 */
public class ExitButtonWatcher implements Behavior, 
PropertyValueChangeListener {
	private SpectroBehavior spectro;
	
	/**
	 * adds target
	 */
	public void addTarget(String componentName, Object obj) {
		if (componentName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)obj);
			System.out.println("spectroBehavior Target added to ExitButtonWatcher...");
		} else {
			System.err.println("ExitButtonWatcher.addTarget: Unknown target " + componentName);
		}
	}

	/**
	 * exits application when exit button is clicked
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event) {
		if (event.key_.equals("exitButton.isClicked")) {
			boolean isExitButtonClicked = ((Boolean)event.source_.getPropertyValue
    			("exitButton.isClicked")).booleanValue();
			if (isExitButtonClicked) {
    		spectro.callExit();
    		}
    	}
	}
}

