package biology.spectro.domain;

import jess.JessException;
import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;

/**
 * This class implements functions of help button
 * @author Chao Han
 *
 */
public class HelpButtonWatcher implements Behavior, 
PropertyValueChangeListener {
	private SpectroBehavior spectro;
	
	/**
	 * adds target
	 */
	public void addTarget(String componentName, Object obj) {
		if (componentName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)obj);
			System.out.println("spectroBehavior Target added to " +
					"HelpButtonWatcher...");
		} else {
			System.err.println("HelpButtonWatcher.addTarget: " +
					"Unknown target " + componentName);
		}
	}

	/**
	 * changes property value of help button and runs help
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event) {
		if (event.key_.equals("HelpButton.isClicked")) {
			boolean isHelpButtonClicked = ((Boolean)event.source_.
				 getPropertyValue("HelpButton.isClicked")).booleanValue();
			if (isHelpButtonClicked) {
				try { 
				 spectro.askForHelp();
				} catch (JessException e) {
					System.out.println("Exception in JESS !!!" + e);
				}	 
			}
		}
	}
}
