package biology.spectro.domain;
 
import jess.JessException;
import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;

/**
 * implements behavior of lid
 * @author Chao Han
 *
 */
public class LidWatcher implements Behavior, PropertyValueChangeListener {
	private SpectroBehavior spectro;

	/**
	 * adds target
	 */
	public void addTarget(String componentName, Object object) {
		if (componentName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)object);
			System.out.println("spectroBehavior Target added to Lidwatcher...");
		} else {
			System.err.println("LidWatcher.addTarget: Unknown target " + componentName);
		}
	}

	/**
	 * changes property value of lid, if lid is open, reading will change slightly
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event) {
		if (event.key_.equals("sampleHolder.isOpen")) {
			boolean isLidOpen = ((Boolean)event.value_).booleanValue();
			try {
				spectro.setLidOpen(isLidOpen);
			} catch (JessException e) {
				System.out.println("LidWatcher exception!!! " + e);
			}
		}
	}
}
