package biology.spectro.domain;

import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;

/**
 * this class implements behavior of meter
 * @author Chao Han
 *
 */
public class MeterWatcher implements Behavior, PropertyValueChangeListener {
	private SpectroBehavior spectro;

	/**
	 * adds target
	 */
	public void addTarget(String componentName, Object object) {
		if (componentName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)object);
			System.out.println("spectroBehavior Target added to Meterwatcher...");
		} else {
			System.err.println("MeterWatcher.addTarget: Unknown target " + componentName);
		}
	}
    

	/**
	 * process event on Meter
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event) {
		if (event.key_.equals("absorbanceMeter.needEnlargedView")) {                     /*if needEnlarge view*/
			boolean isNeedLargeView = ((Boolean)event.value_).booleanValue();
			spectro.setEnlargedView(isNeedLargeView);
		} else if (event.key_.equals("absorbanceMeter.transmittanceReading")) {          
			int reading = ((Double)event.source_.
					getPropertyValue("absorbanceMeter.transmittanceReading")).intValue();
			
			/*when 8<reading<97, button cannot be clicked*/
			if ((reading < 8) || (reading >= 97)) {
				spectro.setConditionSatisfied(reading);
			} else {
				spectro.setButtonStatus(false);
			}
		}
	}
}
