package biology.spectro.domain;

import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;
import manifold.domain.TransformEvent;
import manifold.domain.TransformListener;

/**
 * This class is a watcher for needle,which implements behavior
 * of needle
 * @author Chao Han
 *
 */
public class NeedleWatcher implements Behavior, 
PropertyValueChangeListener, TransformListener {
	private SpectroBehavior spectro;
	
	/**
	 * adds target
	 */
	public void addTarget(String componentName, Object object) {
		if (componentName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)object);
			System.out.println("spectroBehavior Target added to Needlewatcher...");
		} else {
			System.err.println("NeedleWatcher.addTarget: Unknown target " + componentName);
		}
	}
	
	/**
	 * changes properties of needle
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event) {
		if (event.key_.equals("absorbanceMeter.needEnlargedView")) {
			boolean bool = ((Boolean)event.value_).booleanValue();
			spectro.setEnlargedView(bool);
		}
	}

	public void setSelectOccured(TransformEvent event) {	
	}
	public void graspOccured(TransformEvent event) {
	}  
	public void releaseOccured(TransformEvent event) {
	}
	public void transformOccured(TransformEvent event) {
		spectro.setEnlargedView(true);
	}
}