package biology.spectro.domain;

/**
 * this class includes operations under state(off,occupied,closed)
 * because the switch is off, the measure method does nothing and 
 * reading doesn't change. 
 * @author Chao Han
 *
 */
public class OffOccupiedClosed extends SpectroState {
	public OffOccupiedClosed(SpectroBehavior paramSpectroBehavior){
		super(paramSpectroBehavior);
	}
	/**
	 * measures test tube when switch is off
	 * @return number  original value;
	 */
	public double measure() {
		System.out.println("measuring while off, occupied and closed");
		return number;
	}

	/**
	 * flips Switch then the device is on. state changes from OffOccupiedClosed
	 * to OnOccupiedClosed
	 */
	public void flipSwitch(){
		setState(new OnOccupiedClosed(spectro));
	} 
	
	/**
	 * flips Lid then state changes from OffOccupiedClosed to OffOccupiedOpen
	 */
	public void flipLid(){
		setState(new OffOccupiedOpen(spectro));
	}
}
