package biology.spectro.domain;

/**
 * This class includes operations under state(On,occupied,closed), 
 * which is a correct state for measurement. 
 * @author Chao Han
 *
 */
public class OnOccupiedClosed extends SpectroState {
	/**
	 * constructor
	 * @param state
	 */
	public OnOccupiedClosed(SpectroBehavior state) {
		super(state);
	}

	/**
	 * measures test tube. 
	 */
	public double measure(){
		System.out.println("measuring while on, occupied and closed");
		return 0.0D;
	}
 
	/**
	 * flips switch then state changes to OffOccupiedClosed
	 */
	public void flipSwitch(){
		setState(new OffOccupiedClosed(spectro));
	}

	/**
	 * flips lid, then state changes to OnOccupiedOpen
	 */
	public void flipLid(){
		setState(new OnOccupiedOpen(spectro));
	}
}
