package biology.spectro.domain;

/**
 * This class includes operations under state(On,occupied,Open), 
 * @author Chao Han
 */
public class OnOccupiedOpen extends SpectroState {
	public OnOccupiedOpen(SpectroBehavior state) {
		super(state);
	}

	/**
	 * measures
	 */
	public double measure() {
		System.out.println("measuring while on, occupied and open");
		return number;
	}
	
	/**
	 * flips switch, then state changes to OffOccupiedOpen
	 */
	public void flipSwitch(){
		setState(new OffOccupiedOpen(spectro));
	}

	/**
	 * flips lid, then state changes to OnOccupiedClosed
	 */
	public void flipLid(){
		setState(new OnOccupiedClosed(spectro));
	} 

	/**
	 * removes test tube from sample holder, then state changes to
	 * OnUnoccupiedOpen
	 */
	public void removeTestTube(){
		setState(new OnUnoccupiedOpen(spectro));
	}
}