package biology.spectro.domain;

/**
 * This class includes operations under state(On,occupied,closed), 
 * @author Chao Han
 *
 */

public class OnUnoccupiedClosed extends SpectroState {
	/**
	 * Constructor
	 * @param state
	 */
	public OnUnoccupiedClosed(SpectroBehavior state){
		super(state);
	}
	/**
	 * measures test tube
	 */
	public double measure(){
		System.out.println("measuring while on, unoccupied and closed");
		return number;
	}
	
	/**
	 * flip Switch, state changes
	 */
	public void flipSwitch(){
		setState(new OffUnoccupiedClosed(this.spectro));
	}
 
	/**
	 * flips lid, state changes
	 */
	public void flipLid(){
		setState(new OnUnoccupiedOpen(this.spectro));
	}
}
