package biology.spectro.domain;
/**
 * This class includes operations under state(On,Unoccupied,closed), 
 * @author Chao Han
 *
 */
public class OnUnoccupiedOpen extends SpectroState {
	/**
	 * constructor
	 * @param state
	 */
	public OnUnoccupiedOpen(SpectroBehavior state){
		super(state);
	}

	/**
	 * measures test tube
	 */
	public double measure(){
		System.out.println("measuring while on, unoccupied and open");
		return number;
	}
	
	/**
	 * flips switch, state changes. 
	 */
	public void flipSwitch(){
		setState(new OffUnoccupiedOpen(this.spectro));
	}
	
	/**
	 * flips lip, state changes. 
	 */
	public void flipLid(){
		setState(new OnUnoccupiedClosed(this.spectro));
	}
	
	/**
	 * inserts test tube, state changes. 
	 */
	public void setTestTube() {
		setState(new OnOccupiedOpen(this.spectro));
	}
}

 