package biology.spectro.domain;

public abstract class SpectroState {
  
	protected SpectroBehavior spectro;
	protected double          number = 0.0D;

	/**
	 * Constructor for SpectroState
	 * @param state
	 */
	public SpectroState(SpectroBehavior state) {
    
		spectro = state;
	}

	public double measure() {
	 
		return number;
	}
	
	public void flipSwitch() {
	}
	
	public void flipLid() {
	}
	
	public void setTestTube() {
	}

	public void removeTestTube() {
	}

	public void takeDialAction() {
		spectro.measure();
	}

	/**
	 * sets state for spectro
	 * @param state
	 */
	protected void setState(SpectroState state) {
		
		spectro.setState(state);
		spectro.measure();
	} 
}

