
package biology.spectro.domain;

import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;

public class SwitchWatcher implements Behavior,
PropertyValueChangeListener {
	
	private SpectroBehavior spectro_;

	/**
	 * adds target 
	 */
	public void addTarget(String componentName, Object obj) {
    
		if (componentName.equals("spectroBehavior")) {
			spectro_ = ((SpectroBehavior)obj);
			System.out.println("spectroBehavior Target " +
					"added to switchwatcher...");
		} else {
			System.err.println("SwitchWatcher.addTarget: " +
					"Unknown target " + componentName);
		}
	}

	/**
	 * changes property value of Switch
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event){
    
		if (event.key_.equals("switch.state")) {
			boolean isSwitchOn = ((Boolean)event.value_).booleanValue();
			spectro_.flipSwitch(isSwitchOn);
		}
	}
}

