/*
 * TestTubeFigure.java        
 * 
 * Version 1.0
 *
 * 13:43 Dec 1st 2012
 * 
 * @author Junwei Zhao
 */

package biology.spectro.domain;

import flatscape.domain.Transform2D;
import java.awt.geom.AffineTransform;
import manifold.domain.CreateGlyphCommand;
import manifold.domain.Glyph;
import manifold.domain.GlyphProperty;
import manifold.domain.TransformEvent;

public class TestTubeFigure extends Glyph {
	
	/**
	 * Constructor for TestTubeFigure.
	 * adds properties. 
	 * @param cmd
	 * @param trans
	 */
	public TestTubeFigure(CreateGlyphCommand cmd, Transform2D trans){
    super(cmd, trans);
    addGlyphProperty("testTube.isWithinRange", 
    		new GlyphProperty(new Boolean(false), 
    				"tells if the test tube is within the range of sampleHolder", true));

    addGlyphProperty("testTube.isPlaceable", 
    		new GlyphProperty(new Boolean(false), 
    				"tells if the test tube is placeable inside the sampleHolder", true));
  }

	/**
	 * action of grasping
	 */
	public void grasp(){
		super.grasp();
		fireGraspEvent(new TransformEvent(this, new AffineTransform()));
	}
	
	/**
	 * action of releasing
	 */
	public void release(){
		fireReleaseEvent(new TransformEvent(this, new AffineTransform()));
	}
}

