/*
 * TestTubePropertyWatcher.java        
 * 
 * Version 1.0
 *
 * 13:43 Dec 1st 2012
 * 
 * @author Junwei Zhao
 */

package biology.spectro.domain;

import manifold.domain.Behavior;
import manifold.domain.PropertyValueChangeEvent;
import manifold.domain.PropertyValueChangeListener;

/**
 * this is class for property of test tube
 * @author Chao Han
 *
 */
public class TestTubePropertyWatcher implements Behavior, 
PropertyValueChangeListener{
	private SpectroBehavior spectro;

	/**
	 * adds target
	 */
	public void addTarget(String objName, Object obj) {    
		if (objName.equals("spectroBehavior")) {
			spectro = ((SpectroBehavior)obj);
			System.out.println("spectroBehavior Target " +
					"added to TestTubePropertyWatcher...");
		} else {
			System.err.println("TestTubePropertyWatcher.addTarget:" +
					" Unknown target " + objName);
		}
	}

	/**
	 * changes property value
	 * in stage 3, when remove the test tube from sample holder, the needle
	 * needs to change to 0, because the device has been configured correctly. 
	 */
	public void propertyValueChanged(PropertyValueChangeEvent event) {
		if (event.key_.equals("testTube.isWithinRange")) {
      
			boolean isTestTubeWithinRange = ((Boolean)event.source_.
					getPropertyValue("testTube.isWithinRange")).booleanValue();
			if (!isTestTubeWithinRange) {
				spectro.setNeedleBackToZero();
			}
		}
	}
}

