package biology.spectro.domain;

import flatscape.domain.PolyGlyph2D;
import flatscape.domain.RectangleFigure;
import flatscape.domain.TextGlyph;
import java.util.Iterator;
import jess.JessException;
import manifold.domain.Behavior;
import manifold.domain.Glyph;
import manifold.domain.TransformEvent;
import manifold.domain.TransformListener;

/**
 * Sets Wave meter state visible or invisible by clicking on it 
 * @author Chao Han
 *
 */
public class WaveDialBehavior implements Behavior,
TransformListener {
	/*components of wavelength meter*/
	private TextGlyph              waveReading;
  	private RectangleFigure        waveDialBox;
  	private PolyGlyph2D            waveDialTop;
  	private WaveMeterReadingFigure waveMeterFigure;
  	
  	private SpectroBehavior        spectro;
  	private boolean                isVisible = true;   
  	
  	/**
  	 * adds target.
  	 */
  	public void addTarget(String objName, Object obj) {
  		switch(objName) {
  		case "waveReading" : 
  			System.out.println("Adding target...waveReading");
  			waveReading = ((TextGlyph)obj);
  			break;
  		case "waveDialTop" :
  			waveDialTop = ((PolyGlyph2D)obj);
  			break;
  		case "waveDialBox" :
  			waveDialBox = ((RectangleFigure)obj);
  			break;
  		case "waveMeterReadingFigure" :
  			waveMeterFigure = ((WaveMeterReadingFigure)obj);
  			break;
  		case "spectroBehavior" :
  			spectro = ((SpectroBehavior)obj);
  			break;
  		default :
  			System.err.println("WaveDialBehavior.addTarget: " +
  					"Unknown target " + objName);
  			break;
  		}
  	}  	
  
  	public void setSelectOccured(TransformEvent event) {
  	}
  	
  	/**
  	 * action of grasping
  	 */
  	public void graspOccured(TransformEvent event) {
  		((WaveDial)event.source_).putPropertyValue("glyph.isClicked",
			  new Boolean(true));
  		try {
  			spectro.retractWaveDialUnUsed();
  		} catch (JessException e) {
  			System.out.println("Exception in WaveDialHelp!!!" + e);
  		}
	  
  		Iterator iter;
  		
  		/*make top view visible*/
  		if (isVisible) {
  			waveDialBox.putPropertyValue("glyph.visible",
				  new Boolean(true));
  			waveDialTop.putPropertyValue("glyph.visible", 
				  new Boolean(true));
  			
  			iter = waveDialTop.createIterator();
  			while (iter.hasNext()){
  				((Glyph)iter.next()).putPropertyValue("glyph.visible", 
  						new Boolean(true));
  			}
  			waveReading.putPropertyValue("glyph.visible",
  					new Boolean(true));
  			waveMeterFigure.putPropertyValue("glyph.visible", 
  					new Boolean(true));
  		} else {                                                             /*make top view invisible*/
  			waveDialBox.putPropertyValue("glyph.visible",
  					new Boolean(false));
  			waveDialTop.putPropertyValue("glyph.visible", 
  					new Boolean(false));
  			iter = waveDialTop.createIterator();
  			while (iter.hasNext()) {
  				((Glyph)iter.next()).putPropertyValue("glyph.visible",
  						new Boolean(false));
  			}
  			waveReading.putPropertyValue("glyph.visible", 
  					new Boolean(false));
  			waveMeterFigure.putPropertyValue("glyph.visible", 
  					new Boolean(false));
  		}
  		isVisible = !isVisible;
  	}

  	public void releaseOccured(TransformEvent paramTransformEvent) {
  	}

  	public void transformOccured(TransformEvent paramTransformEvent) {
  	}  
}

