package biology.spectro.presentation;

import biology.domain.BackButton;
import biology.presentation.tools.ClickManipulator;
import flatscape.presentation.FlatscapeDocumentView;
import flatscape.presentation.GlyphViewTraversal2D;
import flatscape.presentation.figures.ImageView;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.geom.AffineTransform;
import manifold.domain.Glyph;
import manifold.presentation.Manipulator;

/**
 * This class Draws Back Button 
 * @author Chao Han
 *
 */
public class BackButtonView extends ImageView {
	
	/**
	 * determines whether the back button is clicked
	 */
	public Manipulator createManipulator(MouseEvent mouseEvent) {
		String isclicked = (String)model_.getPropertyValue("glyph.permittedUserTransform");
		if (isclicked.equals("click")) {
			return (Manipulator)new ClickManipulator(documentView_, this);
		}
		new Exception("BackButtonView.createManipulator: Unknown Transform").printStackTrace();
		return null;
	}
	
    /**
     * draws and positions the back button
     */
	protected void draw(GlyphViewTraversal2D view) {
		Graphics2D backButton = view.getPainter();
		
		if (fillColor_ != null){
			fillColor_ = backButton.getColor();
			backButton.setColor(fillColor_);
		}
		
		/*set size of the next button*/
		backButton.translate(width_ / 2.0D, height_ / 2.0D);
		Object obj = documentView_.getInverseTranslation();
		
		/*sets the position of the next button*/
		AffineTransform transform = new AffineTransform();
		transform.setToScale(((AffineTransform)obj).getScaleX(), 
				((AffineTransform)obj).getScaleY());

		boolean isButtonActivated =                                          
				((Boolean)model_.getPropertyValue("button.isActivated")).booleanValue();    
		if (isButtonActivated){                                                /*if back button is activated */
			((BackButton)model_).putPropertyValue("image.location",            /*activated picture*/
					"biology/spectro/resources/backActive.gif");
		} else{
			((BackButton)model_).putPropertyValue("image.location",            /*non-activated picture*/
					"biology/spectro/resources/backInActive.gif");
		}
		
		backButton.drawImage(image_, transform, null);
	}
	
	public BackButtonView(Glyph glyph, FlatscapeDocumentView view) {
		super(glyph, view);
	}
}