package biology.spectro.presentation;

import biology.presentation.tools.ClickManipulator;
import flatscape.presentation.FlatscapeDocumentView;
import flatscape.presentation.GlyphView2D;
import flatscape.presentation.GlyphViewTraversal2D;
import flatscape.presentation.figures.FigureView;
import flatscape.presentation.figures.ImageView;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.geom.AffineTransform;
import java.io.PrintStream;
import manifold.domain.Glyph;
import manifold.presentation.GlyphView;
import manifold.presentation.Manipulator;

public class HelpButtonView extends ImageView {
	public Manipulator createManipulator(MouseEvent event){
		//MouseEvent event;
		String put = (String)model_.getPropertyValue("glyph.permittedUserTransform");
		if (put.equals("click")){
			return (Manipulator)new ClickManipulator(documentView_, this);
		}
		new Exception("HelpButtonView.createManipulator: Unknown Transform").printStackTrace();
		return null;
	}
	protected void draw(GlyphViewTraversal2D t) {
		//GlyphViewTraversal2D t;
		System.out.println("In here..");
		Graphics2D p = t.getPainter();
		if (fillColor_ != null) {
			Color c = p.getColor();
			p.setColor(fillColor_);
		}
		p.translate(-this.width_ / 2.0D, -this.height_ / 2.0D);
		AffineTransform inverse = this.documentView_.getInverseTranslation();
		AffineTransform tx = new AffineTransform();
		tx.setToScale(inverse.getScaleX(), inverse.getScaleY());
		p.drawImage(this.image_, tx, null);
	}
	public HelpButtonView(Glyph model, FlatscapeDocumentView canvas) {
		super(model, canvas);
	}
}

