package biology.spectro.presentation;

import biology.presentation.tools.ClickManipulator;
import flatscape.presentation.FlatscapeDocumentView;
import flatscape.presentation.GlyphViewTraversal2D;
import flatscape.presentation.figures.ImageView;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.geom.AffineTransform;
import manifold.domain.Glyph;
import manifold.presentation.Manipulator;

public class LabButtonView extends ImageView{
	public LabButtonView(Glyph glyph, FlatscapeDocumentView docView)
	{
		super(glyph, docView);
	}
	
	public Manipulator createManipulator(MouseEvent MouseEvent){
		String isClicked = (String)model_.getPropertyValue("glyph.permittedUserTransform");
		if (isClicked.equals("click")){
			return new ClickManipulator(documentView_, this);
		}

		new Exception("LabButtonView.createManipulator: Unknown Transform").printStackTrace();
		return null;
	}
 
	protected void draw(GlyphViewTraversal2D viewTraversal2D) {
		Graphics2D labButton = viewTraversal2D.getPainter();
		if (this.fillColor_ != null){
			fillColor_ = labButton.getColor();
			labButton.setColor(fillColor_);
		}
		
		labButton.translate(width_ / 2.0D, -height_ / 2.0D);
		Object obj = documentView_.getInverseTranslation();
		AffineTransform affineTrans = new AffineTransform();
		affineTrans.setToScale(((AffineTransform)obj).getScaleX(), 
				((AffineTransform)obj).getScaleY());
		labButton.drawImage(image_, affineTrans, null);
	}
}