package biology.spectro.presentation;

import flatscape.presentation.FlatscapeDocumentView;
import flatscape.presentation.GlyphViewTraversal2D;
import flatscape.presentation.figures.RectangleView;
import java.awt.Color;
import java.awt.Graphics2D;
import manifold.domain.Glyph;

public class RackView extends RectangleView {
	protected double width_ = 150.0D;
	protected double height_ = 10.0D;

	/**
	 * sets Rack view
	 * @param glyph    shape    
	 * @param docView  descriptions in XML file
	 */
	public RackView(Glyph glyph, FlatscapeDocumentView docView) {
		super(glyph, docView);
	}
	
	/**
	 * Draws rack
	 */
	protected void draw(GlyphViewTraversal2D view){
		Graphics2D rackView = view.getPainter();
		
		rackView.setColor(Color.black);                                     /*sets rack's color*/
		
		/*set rack's shape*/
		rackView.fillRect((int)-width_ / 2, (int)-height_ / 2,    
				(int)width_ * 2, (int)height_ / 2);
		rackView.fillRect((int)-width_ / 3, (int)height_ * 4, 
				(int)width_ * 13 / 8, (int)height_ / 2);
		rackView.fillRect((int)-width_ / 3, (int)-height_ / 2, 
				(int)this.width_ / 15, (int)this.height_ * 9);
		rackView.fillRect((int)width_ * 5 / 4, (int)-height_ / 2, 
				(int)this.width_ / 15, (int)this.height_ * 9);
		rackView.fillRect((int)-width_ / 2, (int)height_ * 8, 
				(int)this.width_ * 2, (int)this.height_ / 2);
	}
}