package biology.spectro.presentation;

import flatscape.presentation.FlatscapeDocumentView;
import flatscape.presentation.GlyphViewTraversal2D;
import flatscape.presentation.figures.RectangleView;
import java.awt.Graphics2D;
import manifold.domain.Glyph;

/**
 * Sets and draws WaveDialReading 
 * @author Chao Han
 *
 */
public class WaveDialReadingView extends RectangleView {
	
	/**
	 * Draws Wavelength Dial Reading
	 */
	protected void draw(GlyphViewTraversal2D viewTraversal2D) {
		Graphics2D waveDialReading = viewTraversal2D.getPainter();
		if (fillColor_ != null) {
			fillColor_ = waveDialReading.getColor();
			waveDialReading.setColor(fillColor_);
		}
		
		waveDialReading.drawLine((int)-width_ / 2, (int)height_, 
				(int)width_ / 2, (int)height_);
	}
	
	/**
	 * sets Wavelength Dial reading
	 * @param glyph  shape
	 * @param view   descriptions in XML file
	 */
	public WaveDialReadingView(Glyph glyph, FlatscapeDocumentView view) {
		super(glyph, view);
	}
}
